package cn.com.ctop.job.kuaishou.handler;

import cn.com.ctop.kuaishou.modules.batch.service.IKuaiShouVideoGetService;
import cn.com.ctop.kuaishou.modules.material.service.IEtlKuaishouVideoInfoService;
import cn.com.ctop.kuaishou.modules.report.service.IEtlKuaishouAccountMaterialReportDailyService;
import cn.com.ctop.kuaishou.modules.report.service.IKuaishouVideoEtlInfoService;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.jeecg.common.util.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;

@Component
public class KuaishouEtlVideoJob {
    @Autowired
    private IKuaishouVideoEtlInfoService kuaishouVideoEtlInfoService;
    @Autowired
    private IKuaiShouVideoGetService videoGetService;
    @Autowired
    private IEtlKuaishouAccountMaterialReportDailyService materialReportDailyService;
    @Autowired
    private IEtlKuaishouVideoInfoService videoEtlInfoService;

    /**
     * 快手爆款视频数据清洗
     * @throws Exception
     */
    @XxlJob("kuaishouEtlVideoJob")
    public void execute() throws Exception {
        Date startDate = DateUtils.addDay(new Date(), -2);
        for (int i = 0; i <= 2; i++) {
            Date getDate = DateUtils.addDay(startDate, i);
            kuaishouVideoEtlInfoService.etlKuaishouVideoInfo(getDate);
        }
    }

    //TODO 待删除
    @XxlJob("kuaishouEtlProjectVideoJob")
    public void kuaishouEtlProjectVideoJob() throws Exception {
        Date startDate = DateUtils.addDay(new Date(), -2);
        for (int i = 0; i <= 2; i++) {
            Date getDate = DateUtils.addDay(startDate, i);
            kuaishouVideoEtlInfoService.etlKuaishouVideoInfoGroupByProjectId(getDate);
        }
    }

    /**
     * kuaishou_video_get数据清洗
     * 表名:ctop_kuaishou_video_get===>快手-获取视频接口
     * @throws Exception
     */
    @XxlJob("kuaishouEtlVideoBaseInfoJob")
    public void kuaishouEtlVideoBaseInfoJob() throws Exception {
        String statDate = DateUtils.getStartTime(DateUtils.addDay(new Date(), -1));
        videoGetService.etlVideoBaseInfoByStaDate(statDate);
    }

    /**
     * 快手视频信息清洗任务
     */
    @XxlJob("etlFinalKuaishouVideoInfo")
    public void etlKuaishouVideoInfo(){
        Date startDate = DateUtils.addDay(new Date(), -2);
        for(int i=0;i<=2;i++){
            videoEtlInfoService.etlKuaishouVideoInfo(DateUtils.formatDate(DateUtils.addDay(startDate,i)));
        }
    }

    /**
     * 快手数据
     */
    @XxlJob("etlKuaishouAccountMaterialReportInfo")
    public void etlKuaishouAccountMaterialReportInfo(){
        Date startDate = new Date();
        for(int i=1;i<=2;i++){
            materialReportDailyService.etlKuaishouAccountMaterialReportInfo(DateUtils.formatDate(DateUtils.addDay(new Date(),-i)));
        }
    }

    /**
     * 快手清洗视频公司归属
     */
    @XxlJob("etlKuaishouReportCompanyInfo")
    public void etlKuaishouReportCompanyInfo(){
        Date date = DateUtils.addDay(new Date(),-1);
        materialReportDailyService.etlKuaishouReportCompanyInfo(DateUtils.formatDate(date));
    }

    //TODO 待删除
    @XxlJob("etlKuaishouVideoReportStateDate")
    public void etlKuaishouVideoReportStateDate(){
        materialReportDailyService.etlKuaishouVideoReportStateDate();
    }
}
